#import <objc/Object.h>
#import <streams/streams.h>		// NXStream

@class Filter;				// Vorwaertsverweis

@protocol FilterDelegate
- (void) filter: (Filter *) f flag: (char) ch;		// -f
- (int) filter: (Filter *) f arg: (const char *) fnm;	// argument/0
- (int) filter: (Filter *) f fnm: (const char *) fnm stream: (NXStream *) sp;
- (int) filter: (Filter *) f fnm: (const char *) fnm
	line: (const char *) lp len: (unsigned) len;	// eine Zeile
- (int) filter: (Filter *) f close: (const char *) fnm;	// eine Datei fertig
- (int) filter: (Filter *) f exit: (int) code;		// run Resultat
@end
@interface Filter: Object <FilterDelegate>
{					// Empfnger der Nachrichten
	id flag, arg, stream, line, close, quit;
	char ** argv;			// Argumentliste
	char * buf;			// Zeilenpuffer
	unsigned blen, bmax;		// aktuelle, maximale Lnge
@public
	const char * progname;		// argv[0]
	NXStream * out, * err;		// stdout, stderr
}
- initFor: delegate;			// definiert Delegate
- (int) run: (char **) av;		// Hauptprogramm
- (const char *) arg;			// Argumenttext (je nur einmal)
@end
